import { disallowProtoPath, toPath } from "./path.js";
const defMutatorUnsafe = (path) => defMutator(path);
function defMutator(path) {
  const ks = toPath(path);
  disallowProtoPath(ks);
  let [a, b, c, d] = ks;
  switch (ks.length) {
    case 0:
      return (_, x) => x;
    case 1:
      return (s, x) => s ? (s[a] = x, s) : void 0;
    case 2:
      return (s, x) => {
        let t;
        return s ? (t = s[a]) ? (t[b] = x, s) : void 0 : void 0;
      };
    case 3:
      return (s, x) => {
        let t;
        return s ? (t = s[a]) ? (t = t[b]) ? (t[c] = x, s) : void 0 : void 0 : void 0;
      };
    case 4:
      return (s, x) => {
        let t;
        return s ? (t = s[a]) ? (t = t[b]) ? (t = t[c]) ? (t[d] = x, s) : void 0 : void 0 : void 0 : void 0;
      };
    default:
      return (s, x) => {
        let t = s;
        const n = ks.length - 1;
        for (let k = 0; k < n; k++) {
          if (!(t = t[ks[k]]))
            return;
        }
        t[ks[n]] = x;
        return s;
      };
  }
}
export {
  defMutator,
  defMutatorUnsafe
};
